

#include "DblSlider.h"


DblSlider::DblSlider() {
}

DblSlider::~DblSlider() {}


void DblSlider::Init(CEdit *top, CEdit *bot, CEdit *set, CSliderCtrl *sld,
  double topv, double botv, double setv) {
	TopEdit = top;
	BotEdit = bot;
	SetEdit = set;
	Slider = sld;
	Slider->SetRange(0,100);
	TopVal = topv;
	BotVal = botv;
	SetVal = setv;
	CfgLimits();
	ShowLimits();
	ShowSet();
	ShowSld();
}

void DblSlider::CfgLimits() {
	if (SetVal < BotVal) {
		BotVal = SetVal;
		ShowLimits();
		ShowSld();
	}
	if (SetVal > TopVal) {
		TopVal = SetVal;
		ShowLimits();
		ShowSld();
	}
}

void DblSlider::CfgSet() {
	if (SetVal < BotVal) {
		SetVal = BotVal;
		ShowSet();
	}
	if (SetVal > TopVal) {
		SetVal = TopVal;
		ShowSet();
	}
	ShowSld();
}


void DblSlider::ShowLimits() {
	CString	s;

	s.Format("%3.2e", TopVal);
	TopEdit->SetWindowText(s);
	TopEdit->RedrawWindow();

	s.Format("%3.2e", BotVal);
	BotEdit->SetWindowText(s);
	BotEdit->RedrawWindow();
}

void DblSlider::ShowSet() {
	CString	s;

	s.Format("%3.2e", SetVal);
	SetEdit->SetWindowText(s);
	SetEdit->RedrawWindow();
}

void DblSlider::ShowSld() {
	int	val;
	
	SldStep = (TopVal-BotVal)/100.0;
	val = 100-(int)((SetVal-BotVal)/SldStep);
	Slider->SetPos(val);
}


double DblSlider::LimitsChanged() {
	CString	s;

	TopEdit->GetWindowText(s);
	if (s!="") TopVal = atof(s);
	BotEdit->GetWindowText(s);
	if (s!="") BotVal = atof(s);
	CfgSet();
	return(SetVal);
}

double DblSlider::SetChanged() {
	CString s;

	SetEdit->GetWindowText(s);
	if (s!="") SetVal = atof(s);
	CfgLimits();
	ShowSld();
	return(SetVal);
}

double DblSlider::SliderChanged() {
	int		newval;

	newval = 100-Slider->GetPos();
	SetVal = ((double)newval*SldStep) + BotVal;
	ShowSet();
	return(SetVal);
}

double DblSlider::GetVal() {
	return(SetVal);
}



