// FilMovieDlg.h : header file
//

#if !defined(AFX_FILMOVIEDLG_H__BD1C1150_B225_42D5_866E_6C048BC5ECEA__INCLUDED_)
#define AFX_FILMOVIEDLG_H__BD1C1150_B225_42D5_866E_6C048BC5ECEA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "MovieReader.h"
#include "MovieWriter.h"
#include "Manipulator.h"
#include "PicDisplay.h"

#include "DblSlider.h"


/////////////////////////////////////////////////////////////////////////////
// CFilMovieDlg dialog

class CFilMovieDlg : public CDialog
{
// Construction
public:
	CFilMovieDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CFilMovieDlg)
	enum { IDD = IDD_FILMOVIE_DIALOG };
	CButton	m_MarkMinPix;
	CButton	m_ShowWrite;
	CEdit	m_Brightness2;
	CEdit	m_PercDark;
	CEdit	m_MinPixTop;
	CSliderCtrl	m_MinPixSld;
	CEdit	m_MinPixSet;
	CEdit	m_MinPixBot;
	CEdit	m_DarkFacTop;
	CSliderCtrl	m_DarkFacSld;
	CEdit	m_DarkFacSet;
	CEdit	m_DarkFacBot;
	CEdit	m_BrightTop;
	CEdit	m_BrightBot;
	CEdit	m_BrightSet;
	CSliderCtrl	m_BrightSld;
	CEdit	m_BrightnessOut;
	CButton	m_DoManip;
	CButton	m_ShowWhich;
	CStatic	m_Image;
	CEdit	m_FrameTime;
	CEdit	m_FrameNum;
	CEdit	m_Outfile;
	CEdit	m_Infile;
	int		m_ShowGroup;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFilMovieDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CFilMovieDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnInbrowse();
	afx_msg void OnOutbrowse();
	afx_msg void OnChangeInfile();
	afx_msg void OnChangeOutfile();
	afx_msg void OnNext();
	afx_msg void OnFreeplay();
	afx_msg void OnSkip();
	afx_msg void OnChangeBrighttop();
	afx_msg void OnChangeBrightbot();
	afx_msg void OnChangeBrightset();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnChangeMinpixtop();
	afx_msg void OnChangeMinpixset();
	afx_msg void OnChangeMinpixbot();
	afx_msg void OnChangeDarkfactop();
	afx_msg void OnChangeDarkfacset();
	afx_msg void OnChangeDarkfacbot();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnShowwrite();
	afx_msg void OnShowread();
	afx_msg void OnDomanip();
	afx_msg void OnMarkminpix();
	afx_msg void OnChangeFramenum();
	afx_msg void OnKillfocusFramenum();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	void AdjustManipulator();

	MovieReader	*mReader;
	MovieWriter *mWriter;
	Manipulator	*mManipulator;
	PicDisplay	*mDisplay;

	DblSlider	*mBrightnessCtrl;
	DblSlider	*mMinPixCtrl;
	DblSlider	*mDarkFacCtrl;

	BOOL		FreePlayMode;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILMOVIEDLG_H__BD1C1150_B225_42D5_866E_6C048BC5ECEA__INCLUDED_)
