
#include "PicDisplay.h"


PicDisplay::PicDisplay(CWnd *window_in, CStatic *display_in) {
	mDisplayWnd = window_in;
	mDisplay = display_in;
	mBitmap = NULL;
}


PicDisplay::~PicDisplay(void) {
}


void PicDisplay::GenerateTestBitmap(void) {
	BYTE	*parray;
	int		x,y;

	TestMapInfo.bmiHeader.biSize = sizeof(TestMapInfo);
	TestMapInfo.bmiHeader.biWidth = TESTWIDTH;
	TestMapInfo.bmiHeader.biHeight = TESTHEIGHT;
	TestMapInfo.bmiHeader.biPlanes = 1;
	TestMapInfo.bmiHeader.biBitCount = 24;
	TestMapInfo.bmiHeader.biCompression = BI_RGB;
	TestMapInfo.bmiHeader.biSizeImage = 0;		// Specifies the size, in bytes, of the image. This may be set to zero for BI_RGB bitmaps. 
	TestMapInfo.bmiHeader.biXPelsPerMeter = 0;
	TestMapInfo.bmiHeader.biYPelsPerMeter = 0;
	TestMapInfo.bmiHeader.biClrUsed = 0;
	TestMapInfo.bmiHeader.biClrImportant = 0;

	parray = TestMap;
	for (y=0; y<TESTHEIGHT; y++) {
		for (x=0; x<TESTWIDTH; x++) {
			*parray++ = x & 0xFF;
			*parray++ = 0;
			*parray++ = (512-(x+y)) & 0xFF;
		}
	}
}


void PicDisplay::ShowFrame(BITMAPINFO *bmapinfo, BYTE *bmap) {
	if ((bmapinfo == NULL) || (bmap == NULL)) {
		GenerateTestBitmap();
		ShowFrame(&TestMapInfo, TestMap);
	}
	else {
		CClientDC dc(mDisplayWnd);
		BITMAPINFOHEADER	*bmi = &bmapinfo->bmiHeader;

		// Video (and ergo presumably other sources) are giving garbage values in the compression field
		if (bmi->biCompression > 3) bmi->biCompression = BI_RGB; 

		if (mBitmap != NULL) delete mBitmap;
		mBitmap = new CBitmap;

		mBitmap->CreateCompatibleBitmap(&dc, bmi->biWidth, bmi->biHeight);

		SetDIBits((HDC)dc, (HBITMAP)*mBitmap, 0, bmi->biHeight, bmap, bmapinfo, DIB_RGB_COLORS);

		mDisplay->SetBitmap((HBITMAP)*mBitmap);
	}
}


